diff --git a/MAKE.bat b/MAKE.bat
index 306896bf..b086ed69 100644
--- a/MAKE.bat
+++ b/MAKE.bat
@@ -4,7 +4,7 @@
 cd `dirname $0`
 
 # copy demos to root folder. local changes are preserved
-cp demos/*.c . -n
+cp -n demos/*.c .
 
 if [ "$1" = "tidy" ]; then
     rm demo_* 2> /dev/null
@@ -80,6 +80,12 @@ if [ "$(uname)" = "Darwin" ]; then
     chmod +x art/tools/cuttlefish.osx
     chmod +x art/tools/PVRTexToolCLI.osx
 
+    # framework (as dynamic library)
+    if [ "$1" = "dll" ]; then
+        cc -ObjC -dynamiclib -o libfwk.dylib fwk.c -framework cocoa -framework iokit
+        cp libfwk.dylib demos/lua
+    fi
+
     # framework
     echo fwk            && cc -c -ObjC fwk.c -w -g $*
 
diff --git a/README.md b/README.md
index 1083d055..4434a7a9 100644
--- a/README.md
+++ b/README.md
@@ -169,7 +169,7 @@
 //    }
 -->
 
-## Build
+## Build (as static library)
 Type `MAKE.bat` (Win) or `sh MAKE.bat` (Linux/OSX) to build everything. Alternatively,
 
 ```lua
@@ -180,7 +180,11 @@ echo OSX (gcc+clang)       && cc  demo.c -ObjC fwk.c -o demo -w -framework cocoa
 ```
 <!-- - Note: Windows: Assimp.dll may need [this package installed](https://www.microsoft.com/en-us/download/confirmation.aspx?id=30679).-->
 - Note: TCC is partially supported on Windows+Linux. Beware, no threading.
-- Note: FWK as DLL: `cl fwk.c /LD /DAPI=EXPORT && cl demo.c fwk.lib /DAPI=IMPORT`.
+
+## Build (as dynamic library)
+- Windows: `cl fwk.c /LD /DAPI=EXPORT && cl demo.c fwk.lib /DAPI=IMPORT`
+- OSX: `cc -ObjC -dynamiclib -o libfwk.dylib fwk.c -framework cocoa -framework iokit`
+- Test it by typing `cd demos/lua && luajit demo_luajit.lua`
 
 ## Amalgamation
 - Split FWK into separate files by running `art/tools/split.bat` (or `sh art/tools/split.bat` in Linux/OSX).
@@ -206,7 +210,6 @@ echo #endif // FWK_C >> fwk-single-header.c
 
 ## Bindings
 - Luajit: Luajit bindings are provided in the [fwk.lua](demos/lua/fwk.lua) auto-generated file.
-- Luajit: You can test it by typing `cd demos\lua && luajit demo_luajit.lua`
 - Nelua: [Nelua bindings](https://github.com/Rabios/nelua-fun/tree/main/fwk) provided by Rabia Alhaffar.
 
 ## License
@@ -262,7 +265,7 @@ Any contribution to this repository is implicitly subjected to the same release
 - [Rich Geldreich](https://github.com/richgel999/miniz), for miniz (PD).
 - [Ross Williams](http://ross.net/compression/lzrw3a.html) for lzrw3a (PD).
 - [Samuli Raivio](https://github.com/bqqbarbhg/bq_websocket), for bq_websocket (PD).
-- [Sean Barrett](https://github.com/nothings), for stb_image, stb_image_write and stb_vorbis (PD).
+- [Sean Barrett](https://github.com/nothings), for stb_image, stb_image_write, stb_truetype and stb_vorbis (PD).
 - [Sebastian Steinhauer](https://github.com/kieselsteini), for sts_mixer (PD).
 - [Stefan Gustavson](https://github.com/stegu/perlin-noise), for simplex noise (PD).
 - [Vassvik](https://github.com/vassvik/mv_easy_font), for mv_easy_font (Unlicense).
diff --git a/art/docs/docs.html b/art/docs/docs.html
index 18755848..ee08e392 100644
--- a/art/docs/docs.html
+++ b/art/docs/docs.html
@@ -599,11 +599,11 @@
 </script>
 <!-- Markdeep: --><script src="https://casual-effects.com/markdeep/latest/markdeep.min.js?" charset="utf-8"></script>
 
-| Documentation last modified | 14/11/2021        |
+| Documentation last modified | 23/12/2021        |
 |:--------------|:------------|
 |Version:       | 2021.11     |
 |Branch:        | master         |
-|Commit:        | 130              |
+|Commit:        | 36               |
 
 # [F·W·K 2021.11    ](https://github.com/r-lyeh/FWK)
 ## a b o u t
@@ -961,7 +961,7 @@
 - [Rich Geldreich](https://github.com/richgel999/miniz), for miniz (PD).
 - [Ross Williams](http://ross.net/compression/lzrw3a.html) for lzrw3a (PD).
 - [Samuli Raivio](https://github.com/bqqbarbhg/bq_websocket), for bq_websocket (PD).
-- [Sean Barrett](https://github.com/nothings), for stb_image, stb_image_write and stb_vorbis (PD).
+- [Sean Barrett](https://github.com/nothings), for stb_image, stb_image_write, stb_truetype and stb_vorbis (PD).
 - [Sebastian Steinhauer](https://github.com/kieselsteini), for sts_mixer (PD).
 - [Stefan Gustavson](https://github.com/stegu/perlin-noise), for simplex noise (PD).
 - [Vassvik](https://github.com/vassvik/mv_easy_font), for mv_easy_font (Unlicense).
@@ -973,7 +973,7 @@
 
 
 <a href="https://github.com/r-lyeh/FWK/issues"><img alt="Issues" src="https://img.shields.io/github/issues-raw/r-lyeh/FWK.svg"/></a>
-<a href="https://discord.gg/vu6Vt9d"><img alt="Discord" src="https://img.shields.io/discord/270565488365535232.svg?logo=discord&labelColor=5865F2&color=5865F2&logoColor=white"/></a>
+<a href="https://discord.gg/vu6Vt9d"><img alt="Discord" src="https://img.shields.io/discord/270565488365535232?color=5865F2&label=chat&logo=discord&logoColor=white"/></a><br/>
 
 Still looking for alternatives?
 [amulet](https://github.com/ianmaclarty/amulet),
@@ -8961,4 +8961,4 @@
 ## 🄵 functions
 [aabb_closest_point](#aabb_closest_point), [aabb_contains_point](#aabb_contains_point), [aabb_distance2_point](#aabb_distance2_point), [aabb_hit_aabb](#aabb_hit_aabb), [aabb_hit_capsule](#aabb_hit_capsule), [aabb_hit_sphere](#aabb_hit_sphere), [aabb_test_aabb](#aabb_test_aabb), [aabb_test_capsule](#aabb_test_capsule), [aabb_test_poly](#aabb_test_poly), [aabb_test_sphere](#aabb_test_sphere), [abs2](#abs2), [abs3](#abs3), [abs4](#abs4), [absf](#absf), [absi](#absi), [add2](#add2), [add3](#add3), [add34](#add34), [add34x2](#add34x2), [add4](#add4), [addq](#addq), [alert](#alert), [alpha](#alpha), [app_cache](#app_cache), [app_name](#app_name), [app_path](#app_path), [app_reload](#app_reload), [app_temp](#app_temp), [argc](#argc), [argv](#argv), [audio_clip](#audio_clip), [audio_play](#audio_play), [audio_queue](#audio_queue), [audio_stream](#audio_stream), [audio_volume_clip](#audio_volume_clip), [audio_volume_master](#audio_volume_master), [audio_volume_stream](#audio_volume_stream), [battery](#battery), [bgra](#bgra), [big16](#big16), [big16p](#big16p), [big32](#big32), [big32f](#big32f), [big32p](#big32p), [big32pf](#big32pf), [big64](#big64), [big64f](#big64f), [big64p](#big64p), [big64pf](#big64pf), [brdf_lut](#brdf_lut), [breakpoint](#breakpoint), [cache_insert](#cache_insert), [cache_lookup](#cache_lookup), [callstack](#callstack), [callstackf](#callstackf), [camera](#camera), [camera_enable](#camera_enable), [camera_fps](#camera_fps), [camera_get_active](#camera_get_active), [camera_lookat](#camera_lookat), [camera_move](#camera_move), [camera_orbit](#camera_orbit), [capsule_closest_point](#capsule_closest_point), [capsule_distance2_point](#capsule_distance2_point), [capsule_hit_aabb](#capsule_hit_aabb), [capsule_hit_capsule](#capsule_hit_capsule), [capsule_hit_sphere](#capsule_hit_sphere), [capsule_test_aabb](#capsule_test_aabb), [capsule_test_capsule](#capsule_test_capsule), [capsule_test_poly](#capsule_test_poly), [capsule_test_sphere](#capsule_test_sphere), [ceil2](#ceil2), [ceil3](#ceil3), [ceil4](#ceil4), [clamp2](#clamp2), [clamp3](#clamp3), [clamp4](#clamp4), [clampf](#clampf), [clampi](#clampi), [colormap](#colormap), [compose33](#compose33), [compose34](#compose34), [compose44](#compose44), [conjq](#conjq), [cooker_config](#cooker_config), [cooker_jobs](#cooker_jobs), [cooker_progress](#cooker_progress), [cooker_start](#cooker_start), [cooker_stop](#cooker_stop), [copy33](#copy33), [copy34](#copy34), [copy44](#copy44), [cpu_cores](#cpu_cores), [cross2](#cross2), [cross3](#cross3), [cubemap](#cubemap), [cubemap6](#cubemap6), [cubemap_destroy](#cubemap_destroy), [cubemap_get_active](#cubemap_get_active), [data_count](#data_count), [data_find](#data_find), [data_get](#data_get), [data_pop](#data_pop), [data_push](#data_push), [date](#date), [date_epoch](#date_epoch), [ddraw_aabb](#ddraw_aabb), [ddraw_aabb_corners](#ddraw_aabb_corners), [ddraw_arrow](#ddraw_arrow), [ddraw_axis](#ddraw_axis), [ddraw_boid](#ddraw_boid), [ddraw_bone](#ddraw_bone), [ddraw_bounds](#ddraw_bounds), [ddraw_box](#ddraw_box), [ddraw_capsule](#ddraw_capsule), [ddraw_circle](#ddraw_circle), [ddraw_color](#ddraw_color), [ddraw_cone](#ddraw_cone), [ddraw_cube](#ddraw_cube), [ddraw_demo](#ddraw_demo), [ddraw_diamond](#ddraw_diamond), [ddraw_flush](#ddraw_flush), [ddraw_frustum](#ddraw_frustum), [ddraw_grid](#ddraw_grid), [ddraw_ground](#ddraw_ground), [ddraw_hexagon](#ddraw_hexagon), [ddraw_line](#ddraw_line), [ddraw_line_dashed](#ddraw_line_dashed), [ddraw_line_thin](#ddraw_line_thin), [ddraw_normal](#ddraw_normal), [ddraw_ontop](#ddraw_ontop), [ddraw_pentagon](#ddraw_pentagon), [ddraw_plane](#ddraw_plane), [ddraw_point](#ddraw_point), [ddraw_position](#ddraw_position), [ddraw_position_dir](#ddraw_position_dir), [ddraw_pyramid](#ddraw_pyramid), [ddraw_sphere](#ddraw_sphere), [ddraw_square](#ddraw_square), [ddraw_text](#ddraw_text), [ddraw_text2d](#ddraw_text2d), [ddraw_triangle](#ddraw_triangle), [dec2](#dec2), [dec3](#dec3), [dec4](#dec4), [deg](#deg), [det44](#det44), [dialog_load](#dialog_load), [dialog_save](#dialog_save), [diamond](#diamond), [die](#die), [div2](#div2), [div3](#div3), [div4](#div4), [dll](#dll), [dot2](#dot2), [dot3](#dot3), [dot4](#dot4), [dotq](#dotq), [download](#download), [ease_in_back](#ease_in_back), [ease_in_bounce](#ease_in_bounce), [ease_in_circ](#ease_in_circ), [ease_in_cubic](#ease_in_cubic), [ease_in_elastic](#ease_in_elastic), [ease_in_expo](#ease_in_expo), [ease_in_quad](#ease_in_quad), [ease_in_quart](#ease_in_quart), [ease_in_quint](#ease_in_quint), [ease_in_sine](#ease_in_sine), [ease_inout_back](#ease_inout_back), [ease_inout_bounce](#ease_inout_bounce), [ease_inout_circ](#ease_inout_circ), [ease_inout_cubic](#ease_inout_cubic), [ease_inout_elastic](#ease_inout_elastic), [ease_inout_expo](#ease_inout_expo), [ease_inout_perlin](#ease_inout_perlin), [ease_inout_quad](#ease_inout_quad), [ease_inout_quart](#ease_inout_quart), [ease_inout_quint](#ease_inout_quint), [ease_inout_sine](#ease_inout_sine), [ease_linear](#ease_linear), [ease_out_back](#ease_out_back), [ease_out_bounce](#ease_out_bounce), [ease_out_circ](#ease_out_circ), [ease_out_cubic](#ease_out_cubic), [ease_out_elastic](#ease_out_elastic), [ease_out_expo](#ease_out_expo), [ease_out_quad](#ease_out_quad), [ease_out_quart](#ease_out_quart), [ease_out_quint](#ease_out_quint), [ease_out_sine](#ease_out_sine), [ease_ping_pong](#ease_ping_pong), [ease_pong_ping](#ease_pong_ping), [editor](#editor), [editor_active](#editor_active), [euler](#euler), [eulerq](#eulerq), [extract33](#extract33), [fbo](#fbo), [fbo_bind](#fbo_bind), [fbo_destroy](#fbo_destroy), [fbo_unbind](#fbo_unbind), [file_copy](#file_copy), [file_delete](#file_delete), [file_directory](#file_directory), [file_exist](#file_exist), [file_ext](#file_ext), [file_id](#file_id), [file_list](#file_list), [file_load](#file_load), [file_move](#file_move), [file_name](#file_name), [file_normalize](#file_normalize), [file_path](#file_path), [file_read](#file_read), [file_size](#file_size), [file_stamp](#file_stamp), [file_stamp_epoch](#file_stamp_epoch), [file_temp](#file_temp), [file_tempname](#file_tempname), [finite2](#finite2), [finite3](#finite3), [finite4](#finite4), [flag](#flag), [floor2](#floor2), [floor3](#floor3), [floor4](#floor4), [font_color](#font_color), [font_colorize](#font_colorize), [font_face](#font_face), [font_face_from_mem](#font_face_from_mem), [font_goto](#font_goto), [font_highlight](#font_highlight), [font_print](#font_print), [font_rect](#font_rect), [font_scales](#font_scales), [font_xy](#font_xy), [forget](#forget), [fract2](#fract2), [fract3](#fract3), [fract4](#fract4), [frustum44](#frustum44), [frustum_build](#frustum_build), [frustum_test_aabb](#frustum_test_aabb), [frustum_test_sphere](#frustum_test_sphere), [fullscreen_rgb_quad](#fullscreen_rgb_quad), [fullscreen_ycbcr_quad](#fullscreen_ycbcr_quad), [fx_begin](#fx_begin), [fx_enable](#fx_enable), [fx_enable_all](#fx_enable_all), [fx_enabled](#fx_enabled), [fx_end](#fx_end), [fx_load](#fx_load), [fx_name](#fx_name), [gizmo](#gizmo), [gizmo_active](#gizmo_active), [gjk](#gjk), [gjk_analyze](#gjk_analyze), [gjk_quad](#gjk_quad), [has_debugger](#has_debugger), [hash_32](#hash_32), [hash_64](#hash_64), [hash_flt](#hash_flt), [hash_int](#hash_int), [hash_ptr](#hash_ptr), [hash_str](#hash_str), [hexdump](#hexdump), [hexdumpf](#hexdumpf), [id33](#id33), [id34](#id34), [id44](#id44), [identity44](#identity44), [idq](#idq), [image](#image), [image_destroy](#image_destroy), [image_from_mem](#image_from_mem), [inc2](#inc2), [inc3](#inc3), [inc4](#inc4), [input](#input), [input2](#input2), [input_chord2](#input_chord2), [input_chord3](#input_chord3), [input_chord4](#input_chord4), [input_click](#input_click), [input_click2](#input_click2), [input_demo](#input_demo), [input_diff](#input_diff), [input_diff2](#input_diff2), [input_down](#input_down), [input_filter_deadzone](#input_filter_deadzone), [input_filter_deadzone_4way](#input_filter_deadzone_4way), [input_filter_positive](#input_filter_positive), [input_filter_positive2](#input_filter_positive2), [input_frame](#input_frame), [input_frame2](#input_frame2), [input_frames](#input_frames), [input_held](#input_held), [input_idle](#input_idle), [input_load_state](#input_load_state), [input_repeat](#input_repeat), [input_save_state](#input_save_state), [input_send](#input_send), [input_up](#input_up), [input_use](#input_use), [invert34](#invert34), [invert44](#invert44), [len2](#len2), [len2sq](#len2sq), [len3](#len3), [len3sq](#len3sq), [len4](#len4), [len4sq](#len4sq), [lerp34](#lerp34), [less_int](#less_int), [less_ptr](#less_ptr), [less_str](#less_str), [less_u64](#less_u64), [lil16](#lil16), [lil16p](#lil16p), [lil32](#lil32), [lil32f](#lil32f), [lil32p](#lil32p), [lil32pf](#lil32pf), [lil64](#lil64), [lil64f](#lil64f), [lil64p](#lil64p), [lil64pf](#lil64pf), [line_closest_point](#line_closest_point), [line_distance2_point](#line_distance2_point), [lookat44](#lookat44), [map_count](#map_count), [map_erase](#map_erase), [map_find](#map_find), [map_free](#map_free), [map_gc](#map_gc), [map_init](#map_init), [map_insert](#map_insert), [mat44q](#mat44q), [max2](#max2), [max3](#max3), [max4](#max4), [maxf](#maxf), [maxi](#maxi), [mesh_bounds](#mesh_bounds), [mesh_create](#mesh_create), [mesh_destroy](#mesh_destroy), [mesh_render](#mesh_render), [mesh_upgrade](#mesh_upgrade), [min2](#min2), [min3](#min3), [min4](#min4), [minf](#minf), [mini](#mini), [mix2](#mix2), [mix3](#mix3), [mix4](#mix4), [mixf](#mixf), [mixq](#mixq), [model](#model), [model_aabb](#model_aabb), [model_animate](#model_animate), [model_animate_clip](#model_animate_clip), [model_destroy](#model_destroy), [model_from_mem](#model_from_mem), [model_render](#model_render), [model_set_texture](#model_set_texture), [mul2](#mul2), [mul3](#mul3), [mul4](#mul4), [muladd34](#muladd34), [mulq](#mulq), [multiply33x2](#multiply33x2), [multiply34](#multiply34), [multiply34x2](#multiply34x2), [multiply34x3](#multiply34x3), [multiply44](#multiply44), [multiply44x2](#multiply44x2), [multiply44x3](#multiply44x3), [mulv33](#mulv33), [neg2](#neg2), [neg3](#neg3), [neg4](#neg4), [negq](#negq), [norm2](#norm2), [norm3](#norm3), [norm3sq](#norm3sq), [norm4](#norm4), [norm4sq](#norm4sq), [normq](#normq), [object](#object), [object_billboard](#object_billboard), [object_diffuse](#object_diffuse), [object_model](#object_model), [object_move](#object_move), [object_pivot](#object_pivot), [object_position](#object_position), [object_rotate](#object_rotate), [object_scale](#object_scale), [object_teleport](#object_teleport), [option](#option), [optionf](#optionf), [optioni](#optioni), [ortho3](#ortho3), [ortho44](#ortho44), [os_exec](#os_exec), [os_exec_](#os_exec_), [os_exec_output](#os_exec_output), [PANIC](#PANIC), [pbr_material](#pbr_material), [pbr_material_destroy](#pbr_material_destroy), [perspective44](#perspective44), [plane4](#plane4), [pmod2](#pmod2), [pmod3](#pmod3), [pmod4](#pmod4), [pmodf](#pmodf), [poly_alloc](#poly_alloc), [poly_free](#poly_free), [poly_hit_aabb](#poly_hit_aabb), [poly_hit_aabb_transform](#poly_hit_aabb_transform), [poly_hit_capsule](#poly_hit_capsule), [poly_hit_capsule_transform](#poly_hit_capsule_transform), [poly_hit_poly](#poly_hit_poly), [poly_hit_poly_transform](#poly_hit_poly_transform), [poly_hit_sphere](#poly_hit_sphere), [poly_hit_sphere_transform](#poly_hit_sphere_transform), [poly_test_aabb](#poly_test_aabb), [poly_test_aabb_transform](#poly_test_aabb_transform), [poly_test_capsule](#poly_test_capsule), [poly_test_capsule_transform](#poly_test_capsule_transform), [poly_test_poly](#poly_test_poly), [poly_test_poly_transform](#poly_test_poly_transform), [poly_test_sphere](#poly_test_sphere), [poly_test_sphere_transform](#poly_test_sphere_transform), [portname](#portname), [print2](#print2), [print3](#print3), [print33](#print33), [print34](#print34), [print4](#print4), [print44](#print44), [PRINTF](#PRINTF), [printq](#printq), [ptr2](#ptr2), [ptr3](#ptr3), [ptr4](#ptr4), [ptrq](#ptrq), [pyramid](#pyramid), [rad](#rad), [rand64](#rand64), [randf](#randf), [randi](#randi), [randset](#randset), [ray_hit_aabb](#ray_hit_aabb), [ray_hit_plane](#ray_hit_plane), [ray_hit_sphere](#ray_hit_sphere), [ray_hit_triangle](#ray_hit_triangle), [ray_test_aabb](#ray_test_aabb), [ray_test_plane](#ray_test_plane), [ray_test_sphere](#ray_test_sphere), [ray_test_triangle](#ray_test_triangle), [rebase44](#rebase44), [refl2](#refl2), [refl3](#refl3), [refl4](#refl4), [relocate44](#relocate44), [rgba](#rgba), [rng](#rng), [rotate33](#rotate33), [rotate3q](#rotate3q), [rotate3q_2](#rotate3q_2), [rotate44](#rotate44), [rotatex3](#rotatex3), [rotatey3](#rotatey3), [rotatez3](#rotatez3), [rotation33](#rotation33), [rotation44](#rotation44), [rotationq](#rotationq), [rotationq33](#rotationq33), [rotationq44](#rotationq44), [scale2](#scale2), [scale3](#scale3), [scale33](#scale33), [scale34](#scale34), [scale4](#scale4), [scale44](#scale44), [scaleq](#scaleq), [scaling33](#scaling33), [scaling44](#scaling44), [scene_count](#scene_count), [scene_get_active](#scene_get_active), [scene_index](#scene_index), [scene_merge](#scene_merge), [scene_pop](#scene_pop), [scene_push](#scene_push), [scene_render](#scene_render), [scene_spawn](#scene_spawn), [screenshot](#screenshot), [script_bind_class](#script_bind_class), [script_bind_function](#script_bind_function), [script_call](#script_call), [script_init](#script_init), [script_run](#script_run), [script_runfile](#script_runfile), [set_count](#set_count), [set_erase](#set_erase), [set_find](#set_find), [set_free](#set_free), [set_gc](#set_gc), [set_init](#set_init), [set_insert](#set_insert), [shader](#shader), [shader_bind](#shader_bind), [shader_bool](#shader_bool), [shader_colormap](#shader_colormap), [shader_destroy](#shader_destroy), [shader_float](#shader_float), [shader_get_active](#shader_get_active), [shader_int](#shader_int), [shader_mat44](#shader_mat44), [shader_texture](#shader_texture), [shader_texture_unit](#shader_texture_unit), [shader_uint](#shader_uint), [shader_vec2](#shader_vec2), [shader_vec3](#shader_vec3), [shader_vec4](#shader_vec4), [shadowmap](#shadowmap), [shadowmap_begin](#shadowmap_begin), [shadowmap_destroy](#shadowmap_destroy), [shadowmap_end](#shadowmap_end), [shadowmap_set_shadowmatrix](#shadowmap_set_shadowmatrix), [shadowmatrix_ortho](#shadowmatrix_ortho), [shadowmatrix_proj](#shadowmatrix_proj), [signf](#signf), [simplex1](#simplex1), [simplex2](#simplex2), [simplex3](#simplex3), [simplex4](#simplex4), [skybox](#skybox), [skybox_destroy](#skybox_destroy), [skybox_pop_state](#skybox_pop_state), [skybox_push_state](#skybox_push_state), [sleep_ms](#sleep_ms), [sleep_ns](#sleep_ns), [sleep_ss](#sleep_ss), [sleep_us](#sleep_us), [slerpq](#slerpq), [sort_u64](#sort_u64), [sphere_closest_point](#sphere_closest_point), [sphere_hit_aabb](#sphere_hit_aabb), [sphere_hit_capsule](#sphere_hit_capsule), [sphere_hit_sphere](#sphere_hit_sphere), [sphere_test_aabb](#sphere_test_aabb), [sphere_test_capsule](#sphere_test_capsule), [sphere_test_poly](#sphere_test_poly), [sphere_test_sphere](#sphere_test_sphere), [sprite](#sprite), [sprite_flush](#sprite_flush), [stack](#stack), [str16to8](#str16to8), [strbegi](#strbegi), [strcatf](#strcatf), [strcmp_qsort](#strcmp_qsort), [strcmpi_qsort](#strcmpi_qsort), [strcut](#strcut), [strendi](#strendi), [stringf](#stringf), [strjoin](#strjoin), [strlcat](#strlcat), [strlcpy](#strlcpy), [strlerp](#strlerp), [strlower](#strlower), [strmatch](#strmatch), [strrepl](#strrepl), [strsplit](#strsplit), [strstri](#strstri), [strswap](#strswap), [strtok_s](#strtok_s), [strupper](#strupper), [strutf32](#strutf32), [sub2](#sub2), [sub3](#sub3), [sub4](#sub4), [subq](#subq), [tcp_bind](#tcp_bind), [tcp_close](#tcp_close), [tcp_debug](#tcp_debug), [tcp_host](#tcp_host), [tcp_open](#tcp_open), [tcp_peek](#tcp_peek), [tcp_port](#tcp_port), [tcp_recv](#tcp_recv), [tcp_send](#tcp_send), [texture](#texture), [texture_checker](#texture_checker), [texture_compressed](#texture_compressed), [texture_compressed_from_mem](#texture_compressed_from_mem), [texture_create](#texture_create), [texture_destroy](#texture_destroy), [texture_from_mem](#texture_from_mem), [texture_update](#texture_update), [tile](#tile), [time_hh](#time_hh), [time_mm](#time_mm), [time_ms](#time_ms), [time_ns](#time_ns), [time_ss](#time_ss), [time_us](#time_us), [transform33](#transform33), [transform344](#transform344), [transform444](#transform444), [transform_axis](#transform_axis), [transform_matrix](#transform_matrix), [transform_normal](#transform_normal), [transform_point](#transform_point), [transform_quat](#transform_quat), [transform_scaling](#transform_scaling), [transform_tangent](#transform_tangent), [transform_vector](#transform_vector), [transformq](#transformq), [translate44](#translate44), [translation44](#translation44), [transpose44](#transpose44), [tty_color](#tty_color), [tty_reset](#tty_reset), [udp_bind](#udp_bind), [udp_open](#udp_open), [udp_peek](#udp_peek), [udp_recv](#udp_recv), [udp_send](#udp_send), [udp_sendto](#udp_sendto), [ui_active](#ui_active), [ui_begin](#ui_begin), [ui_bits16](#ui_bits16), [ui_bits8](#ui_bits8), [ui_bool](#ui_bool), [ui_button](#ui_button), [ui_clampf](#ui_clampf), [ui_color3](#ui_color3), [ui_color3f](#ui_color3f), [ui_color4](#ui_color4), [ui_color4f](#ui_color4f), [ui_colormap](#ui_colormap), [ui_const_bool](#ui_const_bool), [ui_const_float](#ui_const_float), [ui_const_string](#ui_const_string), [ui_demo](#ui_demo), [ui_dialog](#ui_dialog), [ui_end](#ui_end), [ui_float](#ui_float), [ui_float2](#ui_float2), [ui_float3](#ui_float3), [ui_hover](#ui_hover), [ui_image](#ui_image), [ui_int](#ui_int), [ui_item](#ui_item), [ui_label](#ui_label), [ui_label2](#ui_label2), [ui_list](#ui_list), [ui_menu](#ui_menu), [ui_radio](#ui_radio), [ui_separator](#ui_separator), [ui_short](#ui_short), [ui_slider](#ui_slider), [ui_slider2](#ui_slider2), [ui_string](#ui_string), [ui_toggle](#ui_toggle), [unhash_32](#unhash_32), [unproject44](#unproject44), [vec23](#vec23), [vec34](#vec34), [vec3q](#vec3q), [vec4q](#vec4q), [vfs_find](#vfs_find), [vfs_handle](#vfs_handle), [vfs_list](#vfs_list), [vfs_load](#vfs_load), [vfs_mount](#vfs_mount), [vfs_read](#vfs_read), [vfs_resolve](#vfs_resolve), [vfs_size](#vfs_size), [video](#video), [video_decode](#video_decode), [video_destroy](#video_destroy), [video_duration](#video_duration), [video_has_finished](#video_has_finished), [video_is_paused](#video_is_paused), [video_pause](#video_pause), [video_position](#video_position), [video_seek](#video_seek), [video_textures](#video_textures), [viewport_clear](#viewport_clear), [viewport_clip](#viewport_clip), [viewport_color](#viewport_color), [viewport_color3](#viewport_color3), [vlen](#vlen), [vrealloc](#vrealloc), [watch](#watch), [window_aspect](#window_aspect), [window_create](#window_create), [window_cursor](#window_cursor), [window_delta](#window_delta), [window_flush](#window_flush), [window_focus](#window_focus), [window_fps](#window_fps), [window_frame](#window_frame), [window_fullscreen](#window_fullscreen), [window_handle](#window_handle), [window_has_cursor](#window_has_cursor), [window_has_focus](#window_has_focus), [window_has_fullscreen](#window_has_fullscreen), [window_has_pause](#window_has_pause), [window_has_videorec](#window_has_videorec), [window_has_visible](#window_has_visible), [window_height](#window_height), [window_hook](#window_hook), [window_icon](#window_icon), [window_lock](#window_lock), [window_pause](#window_pause), [window_screenshot](#window_screenshot), [window_swap](#window_swap), [window_time](#window_time), [window_title](#window_title), [window_unhook](#window_unhook), [window_videorec](#window_videorec), [window_visible](#window_visible), [window_width](#window_width), [xrealloc](#xrealloc)
 ## 🄼 macros
-[aabb](#aabb), [array](#array), [array_at](#array_at), [array_back](#array_back), [array_bytes](#array_bytes), [array_cast](#array_cast), [array_clear](#array_clear), [array_copy](#array_copy), [array_count](#array_count), [array_data](#array_data), [array_empty](#array_empty), [array_erase](#array_erase), [array_foreach](#array_foreach), [array_foreach_ptr](#array_foreach_ptr), [array_free](#array_free), [array_init](#array_init), [array_insert](#array_insert), [array_pop](#array_pop), [array_push](#array_push), [array_realloc_](#array_realloc_), [array_reserve](#array_reserve), [array_resize](#array_resize), [array_reverse](#array_reverse), [array_search](#array_search), [array_sort](#array_sort), [array_unique](#array_unique), [array_vlen_](#array_vlen_), [axis](#axis), [capsule](#capsule), [coord_system](#coord_system), [data_float](#data_float), [data_int](#data_int), [data_string](#data_string), [ddraw_text](#ddraw_text), [ddraw_text2d](#ddraw_text2d), [each_array](#each_array), [each_array_ptr](#each_array_ptr), [each_map](#each_map), [each_map_ptr](#each_map_ptr), [each_set](#each_set), [each_set_ptr](#each_set_ptr), [each_substring](#each_substring), [frustum](#frustum), [hit](#hit), [line](#line), [m_finite](#m_finite), [map](#map), [map_cast](#map_cast), [map_clear](#map_clear), [map_count](#map_count), [map_erase](#map_erase), [map_find](#map_find), [map_find_or_add](#map_find_or_add), [map_foreach](#map_foreach), [map_foreach_ptr](#map_foreach_ptr), [map_free](#map_free), [map_gc](#map_gc), [map_init](#map_init), [map_insert](#map_insert), [mat33](#mat33), [mat34](#mat34), [mat44](#mat44), [os_exec](#os_exec), [os_exec_](#os_exec_), [plane](#plane), [poly](#poly), [profile](#profile), [profile_incstat](#profile_incstat), [profile_init](#profile_init), [profile_render](#profile_render), [ptr](#ptr), [quat](#quat), [ray](#ray), [set](#set), [set_cast](#set_cast), [set_clear](#set_clear), [set_count](#set_count), [set_erase](#set_erase), [set_find](#set_find), [set_find_or_add](#set_find_or_add), [set_foreach](#set_foreach), [set_foreach_ptr](#set_foreach_ptr), [set_free](#set_free), [set_gc](#set_gc), [set_init](#set_init), [set_insert](#set_insert), [sphere](#sphere), [str](#str), [strcatf](#strcatf), [strcmpi](#strcmpi), [stringf](#stringf), [strtok_r](#strtok_r), [triangle](#triangle), [ui_const_stringf](#ui_const_stringf), [ui_labelf](#ui_labelf), [va](#va), [vec2](#vec2), [vec3](#vec3)
\ No newline at end of file
+[aabb](#aabb), [array](#array), [array_at](#array_at), [array_back](#array_back), [array_bytes](#array_bytes), [array_cast](#array_cast), [array_clear](#array_clear), [array_copy](#array_copy), [array_count](#array_count), [array_data](#array_data), [array_empty](#array_empty), [array_erase](#array_erase), [array_foreach](#array_foreach), [array_foreach_ptr](#array_foreach_ptr), [array_free](#array_free), [array_init](#array_init), [array_insert](#array_insert), [array_pop](#array_pop), [array_push](#array_push), [array_realloc_](#array_realloc_), [array_reserve](#array_reserve), [array_resize](#array_resize), [array_reverse](#array_reverse), [array_search](#array_search), [array_sort](#array_sort), [array_unique](#array_unique), [array_vlen_](#array_vlen_), [axis](#axis), [capsule](#capsule), [coord_system](#coord_system), [data_count](#data_count), [data_float](#data_float), [data_int](#data_int), [data_string](#data_string), [ddraw_text](#ddraw_text), [ddraw_text2d](#ddraw_text2d), [each_array](#each_array), [each_array_ptr](#each_array_ptr), [each_map](#each_map), [each_map_ptr](#each_map_ptr), [each_set](#each_set), [each_set_ptr](#each_set_ptr), [each_substring](#each_substring), [frustum](#frustum), [hit](#hit), [line](#line), [m_finite](#m_finite), [map](#map), [map_cast](#map_cast), [map_clear](#map_clear), [map_count](#map_count), [map_erase](#map_erase), [map_find](#map_find), [map_find_or_add](#map_find_or_add), [map_foreach](#map_foreach), [map_foreach_ptr](#map_foreach_ptr), [map_free](#map_free), [map_gc](#map_gc), [map_init](#map_init), [map_insert](#map_insert), [mat33](#mat33), [mat34](#mat34), [mat44](#mat44), [os_exec](#os_exec), [os_exec_](#os_exec_), [plane](#plane), [poly](#poly), [profile](#profile), [profile_incstat](#profile_incstat), [profile_init](#profile_init), [profile_render](#profile_render), [ptr](#ptr), [quat](#quat), [ray](#ray), [set](#set), [set_cast](#set_cast), [set_clear](#set_clear), [set_count](#set_count), [set_erase](#set_erase), [set_find](#set_find), [set_find_or_add](#set_find_or_add), [set_foreach](#set_foreach), [set_foreach_ptr](#set_foreach_ptr), [set_free](#set_free), [set_gc](#set_gc), [set_init](#set_init), [set_insert](#set_insert), [sphere](#sphere), [str](#str), [strcatf](#strcatf), [strcmpi](#strcmpi), [stringf](#stringf), [strtok_r](#strtok_r), [triangle](#triangle), [ui_const_stringf](#ui_const_stringf), [ui_labelf](#ui_labelf), [va](#va), [vec2](#vec2), [vec3](#vec3)
\ No newline at end of file
diff --git a/art/tools/ass2iqe.linux b/art/tools/ass2iqe.linux
index ed47cf7f..6583e93f 100755
Binary files a/art/tools/ass2iqe.linux and b/art/tools/ass2iqe.linux differ
diff --git a/art/tools/ass2iqe.obj b/art/tools/ass2iqe.obj
deleted file mode 100644
index b2910be0..00000000
Binary files a/art/tools/ass2iqe.obj and /dev/null differ
diff --git a/art/tools/assimp_build.bat b/art/tools/assimp_build.bat
index d7a83bbf..02eca55e 100644
--- a/art/tools/assimp_build.bat
+++ b/art/tools/assimp_build.bat
@@ -4,13 +4,13 @@
 cd `dirname $0`
 
 git clone https://github.com/assimp/assimp && cd assimp
-cmake -DCMAKE_BUILD_TYPE=Release .
+cmake -DCMAKE_BUILD_TYPE=Release -DASSIMP_BUILD_TESTS=OFF .
 make -j 8
 cp bin/libassimp.so ../libassimp.so
 cp bin/libassimp.so ../libassimp.so.5
-cp bin/libassimp.so ../libassimp.so.5.0.1
+cp bin/libassimp.so ../libassimp.so.5.1.4
 cd ..
-gcc ass2iqe.c -o ass2iqe.linux -O2 -I assimp/include/ libassimp.so -lm
+cc ass2iqe.c -o ass2iqe.linux -O2 -I assimp/include/ libassimp.so -lm
 
 exit
 
diff --git a/art/tools/libassimp.so b/art/tools/libassimp.so
index a6d1554f..c82bb219 100644
Binary files a/art/tools/libassimp.so and b/art/tools/libassimp.so differ
diff --git a/art/tools/libassimp.so.5 b/art/tools/libassimp.so.5
index a6d1554f..c82bb219 100644
Binary files a/art/tools/libassimp.so.5 and b/art/tools/libassimp.so.5 differ
diff --git a/art/tools/libassimp.so.5.0.1 b/art/tools/libassimp.so.5.1.4
similarity index 58%
rename from art/tools/libassimp.so.5.0.1
rename to art/tools/libassimp.so.5.1.4
index a6d1554f..c82bb219 100644
Binary files a/art/tools/libassimp.so.5.0.1 and b/art/tools/libassimp.so.5.1.4 differ
diff --git a/art/tools/sfxr2wav.linux b/art/tools/sfxr2wav.linux
index 12ec9317..d8062e9d 100755
Binary files a/art/tools/sfxr2wav.linux and b/art/tools/sfxr2wav.linux differ
diff --git a/art/tools/sfxr2wav.osx b/art/tools/sfxr2wav.osx
new file mode 100644
index 00000000..397c350e
Binary files /dev/null and b/art/tools/sfxr2wav.osx differ
diff --git a/demos/lua/fwk.dll b/demos/lua/fwk.dll
index 07a5f462..76edce6c 100644
Binary files a/demos/lua/fwk.dll and b/demos/lua/fwk.dll differ
diff --git a/demos/lua/fwk.lua b/demos/lua/fwk.lua
index 7b194981..671b26c3 100644
--- a/demos/lua/fwk.lua
+++ b/demos/lua/fwk.lua
@@ -1,4 +1,4 @@
---autogenerated luajit bindings. do not edit. 2021/11/01
+--autogenerated luajit bindings. do not edit. 2021/12/23
 local ffi = require("ffi")
 ffi.cdef([[
 //lcpp INF [0000] vec2: macro name but used as C declaration in:typedef union vec2 { struct { float x,y; }; struct { float r,g; }; struct { float w,h; }; struct { float min,max; }; float v[1]; } vec2;
diff --git a/fwk.c b/fwk.c
index f30c4a14..01c8331f 100644
--- a/fwk.c
+++ b/fwk.c
@@ -2814,13 +2814,33 @@ int cooker_jobs() {
 }
 
 void cooker_config( const char *art_path, const char *tools_path, const char *fwk_ini ) { // @todo: test run-from-"bin/" case on Linux.
-   ART = STRDUP( art_path ? art_path : ART );
-   TOOLS = STRDUP( tools_path ? tools_path : TOOLS );
-   FWK_INI = STRDUP( fwk_ini ? fwk_ini : FWK_INI );
+    const char *rules = file_read(fwk_ini ? fwk_ini : FWK_INI);
+    if( rules && rules[0] != 0 ) {
+        if( strstr(rules, "ART=") ) {
+            ART = STRDUP( strstr(rules, "ART=") + 4 ); // @leak
+            char *r = strchr( ART, '\r' ); if(r) *r = 0;
+            char *n = strchr( ART, '\n' ); if(n) *n = 0;
+            char *s = strchr( ART, ';' );  if(s) *s = 0;
+            char *w = strchr( ART, ' ' );  if(w) *w = 0;
+            if( ART[strlen(ART) - 1] != '/' ) strcat((char*)ART, "/");
+        }
+        if( strstr(rules, "TOOLS=") ) {
+            TOOLS = STRDUP( strstr(rules, "TOOLS=") + 6 ); // @leak
+            char *r = strchr( TOOLS, '\r' ); if(r) *r = 0;
+            char *n = strchr( TOOLS, '\n' ); if(n) *n = 0;
+            char *s = strchr( TOOLS, ';' );  if(s) *s = 0;
+            char *w = strchr( TOOLS, ' ' );  if(w) *w = 0;
+            if( TOOLS[strlen(TOOLS) - 1] != '/' ) strcat((char*)TOOLS, "/");
+        }
+    }
+
+    ART = STRDUP( art_path ? art_path : ART );
+    TOOLS = STRDUP( tools_path ? tools_path : TOOLS );
+    FWK_INI = STRDUP( fwk_ini ? fwk_ini : FWK_INI );
 
-   assert( ART[strlen(ART) - 1] == '/' );
-   assert( TOOLS[strlen(TOOLS) - 1] == '/' );
-   assert( FWK_INI[strlen(FWK_INI) - 1] != '/' );
+    assert( ART[strlen(ART) - 1] == '/' );
+    assert( TOOLS[strlen(TOOLS) - 1] == '/' );
+    assert( FWK_INI[strlen(FWK_INI) - 1] != '/' );
 }
 
 // ----------------------------------------------------------------------------
@@ -2891,7 +2911,7 @@ json5* data_node(const char *keypath) {
     return r;
 }
 
-int data_count(const char *keypath) {
+int (data_count)(const char *keypath) {
     json5* j = data_node(keypath);
     return j ? j->count : 0;
 }
@@ -15046,6 +15066,7 @@ void fwk_init() {
         }
 
         // create or update cook.zip file
+        cooker_config(NULL, NULL, NULL);
         if( file_directory(TOOLS) && cooker_jobs() ) {
             cooker_start( "**", 0|COOKER_ASYNC );
         }
diff --git a/fwk.h b/fwk.h
index 1d940e37..a026ed0d 100644
--- a/fwk.h
+++ b/fwk.h
@@ -939,8 +939,11 @@ API int         data_count(const char *keypath);
 #define         data_int(...)    (data_get(stringf("i" __VA_ARGS__)).i)
 #define         data_float(...)  (data_get(stringf("f" __VA_ARGS__)).f)
 #define         data_string(...) (data_get(stringf("s" __VA_ARGS__)).s)
+#define         data_count(...)   data_count(stringf(__VA_ARGS__))
 API bool    data_pop();
 
+// syntax sugars
+
 
 #line 0
 #line 1 "fwk_dll.h"
